import streamlit as st


@st.cache
def Derwent_Profile():
    '''
    Derwent profile
    '''
    VOLTAGE_BREAKPOINTS = [150, 180, 220, 240, 260, 280, 300, 320, 340]
    MAX_VOLTAGE = max(VOLTAGE_BREAKPOINTS)
    MAX_STATOR_CURRENT = 450
    POLE_PAIRS = 6

    SPEED_BREAKPOINTS = [0, 884.6153846, 1769.230769, 2653.846154, 3538.461538, 4423.076923, 5307.692308, 6192.307692, 7076.923077, 7961.538462, 8846.153846, 9730.769231, 10615.38462, 11500]
    MAX_SPEED = max(SPEED_BREAKPOINTS)

    PEAK_TORQUE = [[286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [285.583418848043, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [226.795429163605, 260.182246909201, 285.668297835937, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [177.949324826979, 211.056714723455, 248.305675502718, 262.937300376296, 275.147254952391, 283.230963035568, 286.919087900264, 286.919087900264, 286.919087900264],
                   [144.891028035928, 173.978737566603, 209.405976875078, 225.618808222456, 240.082879946902, 253.06087810775, 264.517631349955, 274.335064855334, 281.290364913358],
                   [121.803745350631, 147.041575986411, 179.356860646952, 194.370807996921, 208.359019691151, 221.768320414942, 234.495943437085, 246.21100985348, 256.646007820339],
                   [104.957061890792, 127.274225338822, 155.885831905037, 169.476201844729, 182.845274893292, 195.485504412679, 207.755264047202, 219.464318293347, 230.398713742742],
                   [91.9218231078475, 111.704669998831, 137.357269095916, 150.058774482126, 162.044593954854, 173.942647670478, 185.43009401419, 196.508012927248, 207.205047233369],
                   [81.7462770552869, 99.6122066558159, 122.813871777867, 134.140705875621, 145.349440494131, 156.384973722967, 166.960335656497, 177.421939409628, 187.541229172617],
                   [73.5923408504398, 89.7601872811817, 110.997302476172, 121.270027376933, 131.487251652779, 141.620308519637, 151.648379123474, 161.111122593735, 170.916137877905],
                   [66.8738395913367, 81.5802008351773, 101.08002802521, 110.579343462692, 120.144951680198, 129.409350434029, 138.779296537114, 147.544523344774, 156.494990238726],
                   [61.3306437699175, 74.7893080010025, 92.6910246639165, 101.607847894947, 110.463342847128, 119.077163712693, 127.693458508102, 136.125830040349, 144.340017940942],
                   [56.5576182533882, 69.0155011018235, 85.5907455103901, 93.8012497471727, 102.020210621593, 110.103406782343, 118.182391227428, 126.206497332946, 133.974110393119]]
    
    MAX_TORQUE = max(max(PEAK_TORQUE))

    profile_dict = {
        "Voltage Breakpoints": VOLTAGE_BREAKPOINTS,
        "Speed Breakpoints": SPEED_BREAKPOINTS,
        "Max Voltage": MAX_VOLTAGE,
        "Max Speed": MAX_SPEED,
        "Max Torque": MAX_TORQUE,
        "Max Stator Current": MAX_STATOR_CURRENT,
        "Peak Torque": PEAK_TORQUE,
        "Pole Pairs": POLE_PAIRS
    }

    return profile_dict

@st.cache
def Oxford_Profile():
    '''
    Oxford profile
    '''
    VOLTAGE_BREAKPOINTS = [150, 180, 220, 240, 260, 280, 300, 320, 340]
    MAX_VOLTAGE = max(VOLTAGE_BREAKPOINTS)
    MAX_STATOR_CURRENT = 450
    POLE_PAIRS = 6

    SPEED_BREAKPOINTS = [0, 884.6153846, 1769.230769, 2653.846154, 3538.461538, 4423.076923, 5307.692308, 6192.307692, 7076.923077, 7961.538462, 8846.153846, 9730.769231, 10615.38462, 11500]
    MAX_SPEED = max(SPEED_BREAKPOINTS)

    PEAK_TORQUE = [[286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [285.583418848043, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [226.795429163605, 260.182246909201, 285.668297835937, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [177.949324826979, 211.056714723455, 248.305675502718, 262.937300376296, 275.147254952391, 283.230963035568, 286.919087900264, 286.919087900264, 286.919087900264],
                   [144.891028035928, 173.978737566603, 209.405976875078, 225.618808222456, 240.082879946902, 253.06087810775, 264.517631349955, 274.335064855334, 281.290364913358],
                   [121.803745350631, 147.041575986411, 179.356860646952, 194.370807996921, 208.359019691151, 221.768320414942, 234.495943437085, 246.21100985348, 256.646007820339],
                   [104.957061890792, 127.274225338822, 155.885831905037, 169.476201844729, 182.845274893292, 195.485504412679, 207.755264047202, 219.464318293347, 230.398713742742],
                   [91.9218231078475, 111.704669998831, 137.357269095916, 150.058774482126, 162.044593954854, 173.942647670478, 185.43009401419, 196.508012927248, 207.205047233369],
                   [81.7462770552869, 99.6122066558159, 122.813871777867, 134.140705875621, 145.349440494131, 156.384973722967, 166.960335656497, 177.421939409628, 187.541229172617],
                   [73.5923408504398, 89.7601872811817, 110.997302476172, 121.270027376933, 131.487251652779, 141.620308519637, 151.648379123474, 161.111122593735, 170.916137877905],
                   [66.8738395913367, 81.5802008351773, 101.08002802521, 110.579343462692, 120.144951680198, 129.409350434029, 138.779296537114, 147.544523344774, 156.494990238726],
                   [61.3306437699175, 74.7893080010025, 92.6910246639165, 101.607847894947, 110.463342847128, 119.077163712693, 127.693458508102, 136.125830040349, 144.340017940942],
                   [56.5576182533882, 69.0155011018235, 85.5907455103901, 93.8012497471727, 102.020210621593, 110.103406782343, 118.182391227428, 126.206497332946, 133.974110393119]]
    
    MAX_TORQUE = max(max(PEAK_TORQUE))

    profile_dict = {
        "Voltage Breakpoints": VOLTAGE_BREAKPOINTS,
        "Speed Breakpoints": SPEED_BREAKPOINTS,
        "Max Voltage": MAX_VOLTAGE,
        "Max Speed": MAX_SPEED,
        "Max Torque": MAX_TORQUE,
        "Max Stator Current": MAX_STATOR_CURRENT,
        "Peak Torque": PEAK_TORQUE,
        "Pole Pairs": POLE_PAIRS
    }

    return profile_dict

@st.cache
def Bowfell_Profile():
    '''
    Bowfell profile
    '''
    VOLTAGE_BREAKPOINTS = [150, 180, 220, 240, 260, 280, 300, 320, 340]
    MAX_VOLTAGE = max(VOLTAGE_BREAKPOINTS)
    MAX_STATOR_CURRENT = 450
    POLE_PAIRS = 6

    SPEED_BREAKPOINTS = [0, 884.6153846, 1769.230769, 2653.846154, 3538.461538, 4423.076923, 5307.692308, 6192.307692, 7076.923077, 7961.538462, 8846.153846, 9730.769231, 10615.38462, 11500]
    MAX_SPEED = max(SPEED_BREAKPOINTS)

    PEAK_TORQUE = [[286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [285.583418848043, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [226.795429163605, 260.182246909201, 285.668297835937, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264, 286.919087900264],
                   [177.949324826979, 211.056714723455, 248.305675502718, 262.937300376296, 275.147254952391, 283.230963035568, 286.919087900264, 286.919087900264, 286.919087900264],
                   [144.891028035928, 173.978737566603, 209.405976875078, 225.618808222456, 240.082879946902, 253.06087810775, 264.517631349955, 274.335064855334, 281.290364913358],
                   [121.803745350631, 147.041575986411, 179.356860646952, 194.370807996921, 208.359019691151, 221.768320414942, 234.495943437085, 246.21100985348, 256.646007820339],
                   [104.957061890792, 127.274225338822, 155.885831905037, 169.476201844729, 182.845274893292, 195.485504412679, 207.755264047202, 219.464318293347, 230.398713742742],
                   [91.9218231078475, 111.704669998831, 137.357269095916, 150.058774482126, 162.044593954854, 173.942647670478, 185.43009401419, 196.508012927248, 207.205047233369],
                   [81.7462770552869, 99.6122066558159, 122.813871777867, 134.140705875621, 145.349440494131, 156.384973722967, 166.960335656497, 177.421939409628, 187.541229172617],
                   [73.5923408504398, 89.7601872811817, 110.997302476172, 121.270027376933, 131.487251652779, 141.620308519637, 151.648379123474, 161.111122593735, 170.916137877905],
                   [66.8738395913367, 81.5802008351773, 101.08002802521, 110.579343462692, 120.144951680198, 129.409350434029, 138.779296537114, 147.544523344774, 156.494990238726],
                   [61.3306437699175, 74.7893080010025, 92.6910246639165, 101.607847894947, 110.463342847128, 119.077163712693, 127.693458508102, 136.125830040349, 144.340017940942],
                   [56.5576182533882, 69.0155011018235, 85.5907455103901, 93.8012497471727, 102.020210621593, 110.103406782343, 118.182391227428, 126.206497332946, 133.974110393119]]
    
    MAX_TORQUE = max(max(PEAK_TORQUE))

    profile_dict = {
        "Voltage Breakpoints": VOLTAGE_BREAKPOINTS,
        "Speed Breakpoints": SPEED_BREAKPOINTS,
        "Max Voltage": MAX_VOLTAGE,
        "Max Speed": MAX_SPEED,
        "Max Torque": MAX_TORQUE,
        "Max Stator Current": MAX_STATOR_CURRENT,
        "Peak Torque": PEAK_TORQUE,
        "Pole Pairs": POLE_PAIRS
    }

    return profile_dict
